=== debian/control ===
Source: rawtherapee
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Philip Rinn <rinni@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libcanberra-gtk3-dev,
               libexiv2-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgtk-3-dev (>=3.24.3),
               libgtkmm-3.0-dev (>= 3.24),
               libiptcdata0-dev,
               libjpeg-dev,
               libjxl-dev,
               liblcms2-dev,
               liblensfun-dev,
               libpng-dev,
               libraw-dev (>= 0.21),
               librsvg2-dev (>= 2.52),
               libsigc++-2.0-dev,
               libtiff-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/rawtherapee
Vcs-Git: https://salsa.debian.org/debian/rawtherapee.git
Homepage: https://www.rawtherapee.com
Rules-Requires-Root: no

Package: rawtherapee
Architecture: any
Depends: rawtherapee-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: raw image converter and digital photo processor
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.

Package: rawtherapee-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: rawtherapee (= ${source:Version})
Replaces: rawtherapee (<< 4.0.9)
Breaks: rawtherapee (<< 4.0.9)
Description: raw image converter and digital photo processor (data files)
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.
 .
 This package contains the data files.
