=== rtdata/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,9 @@
 install(FILES ${INPUTICCFILES} DESTINATION "${DATADIR}/iccprofiles/input")
 install(FILES ${OUTPUTICCFILES} DESTINATION "${DATADIR}/iccprofiles/output")
 install(FILES ${DCPFILES} DESTINATION "${DATADIR}/dcpprofiles")
+install(FILES "cammatrices.json" DESTINATION "${DATADIR}")
+install(FILES "dcraw.json" DESTINATION "${DATADIR}")
+install(FILES "rt.json" DESTINATION "${DATADIR}")
 install(FILES ${OPTIONSFILE} DESTINATION "${DATADIR}" PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ RENAME options)
 
 install(DIRECTORY "${PROFILESDIR}" DESTINATION "${DATADIR}" FILES_MATCHING PATTERN "*.pp3")
