=== debian/changelog ===
rawtherapee (5.12-2) unstable; urgency=medium

  * Fix crash with updated gtkmm stack (closes: #1119860).

 -- Philip Rinn <rinni@debian.org>  Sun, 02 Nov 2025 19:07:31 +0100

rawtherapee (5.12-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2 (no changes necessary).

 -- Philip Rinn <rinni@debian.org>  Sun, 10 Aug 2025 13:00:51 +0200

rawtherapee (5.11-2) unstable; urgency=medium

  * Bump build dependency librsvg2-dev to >= 2.52

 -- Philip Rinn <rinni@debian.org>  Wed, 02 Oct 2024 18:20:47 +0200

rawtherapee (5.11-1) unstable; urgency=medium

  * New upstream release:
    - Repack source to exclude embedded LibRaw
    - Add build dependency libraw-dev (>= 0.21)
    - Add build dependency libjxl-dev
  * Bump Standards-Version to 4.7.0 (no changes necessary).

 -- Philip Rinn <rinni@debian.org>  Sun, 29 Sep 2024 19:48:11 +0200
