=== debian/watch ===
version=4
https://rawtherapee.com/shared/source/rawtherapee-(\d[\d.]*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)
